"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _Icons = require("../../Atoms/Icons");

var _Inputs = require("../../Atoms/Inputs");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _templateObject5() {
  var data = _taggedTemplateLiteral(["\n  display: flex;\n  flex-direction: row;\n  justify-content: center;\n  align-items: center;\n  width: auto;\n  min-width: 4rem;\n  height: 3.5rem;\n  padding: 1rem;\n  box-sizing: border-box;\n  font-family: ", ";\n  font-size: 1.75rem;\n  font-weight: 400;\n  color: ", ";\n  background-color: ", ";\n  border-top-right-radius: 0.125rem;\n  border-bottom-right-radius: 0.125rem;\n  white-space: nowrap;\n\n  &:hover {\n    background-color: ", ";\n    cursor: pointer;\n  }\n"]);

  _templateObject5 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4() {
  var data = _taggedTemplateLiteral(["\n  height: 3.5rem;\n  padding-left: 3rem;\n  background-color: inherit;\n  border-color: transparent;\n"]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = _taggedTemplateLiteral(["\n  fill: ", ";\n\n  &:hover {\n    fill: ", ";\n  }\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = _taggedTemplateLiteral(["\n  position: absolute;\n  top: 50%;\n  left: 1rem;\n  margin-top: -10px;\n  display: flex;\n  flex-direction: row;\n  justify-content: center;\n  align-items: center;\n  background-color: inherit;\n  border-color: transparent;\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n  position: relative;\n  display: flex;\n  flex-direction: row;\n  justify-content: flex-start;\n  align-items: center;\n  width: ", ";\n  background-color: ", ";\n  box-shadow: 0 2px 8px 1px ", ";\n  border-radius: 0.125rem;\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var Wrapper = _styledComponents.default.div(_templateObject(), function (props) {
  return props.width;
}, function (props) {
  return props.theme['searchBarBackgroundColor'];
}, function (props) {
  return props.theme['searchBarShadowColor'];
});

var IconContainer = _styledComponents.default.div(_templateObject2());

var SearchIcon = (0, _styledComponents.default)(_Icons.FasSearch).attrs({
  selectable: false,
  size: '20px'
})(_templateObject3(), function (props) {
  return props.theme['searchBarIconColor'];
}, function (props) {
  return props.theme['searchBarIconColor'];
});
var SearchInput = (0, _styledComponents.default)(_Inputs.Input)(_templateObject4());

var GoContainer = _styledComponents.default.div(_templateObject5(), function (props) {
  return props.theme['fontPrimary'];
}, function (props) {
  return props.theme['searchBarSubmitColor'];
}, function (props) {
  return props.theme['searchBarSubmitBackgroundColor'];
}, function (props) {
  return props.theme['searchBarSubmitHoverBackgroundColor'];
});

var GoLabel = function GoLabel() {
  return _react.default.createElement(_react.default.Fragment, null, "Go");
};

var SearchBar = function SearchBar(_ref) {
  var children = _ref.children,
      renderSubmit = _ref.renderSubmit,
      width = _ref.width,
      onChange = _ref.onChange,
      onClick = _ref.onClick,
      rest = _objectWithoutProperties(_ref, ["children", "renderSubmit", "width", "onChange", "onClick"]);

  return _react.default.createElement(Wrapper, {
    width: width
  }, _react.default.createElement(IconContainer, null, _react.default.createElement(SearchIcon, null)), _react.default.createElement(SearchInput, _extends({
    onChange: onChange
  }, rest)), _react.default.createElement(GoContainer, {
    onClick: onClick
  }, renderSubmit()));
};

SearchBar.propTypes = {
  children: _propTypes.default.node,
  onChange: _propTypes.default.func,
  onClick: _propTypes.default.func,
  renderSubmit: _propTypes.default.func,
  value: _propTypes.default.any,
  width: _propTypes.default.string
};
SearchBar.defaultProps = {
  renderSubmit: GoLabel,
  width: '100%'
};
var _default = SearchBar;
exports.default = _default;